#TEMPLATE(ReportAsEmail,'Email Programming Templates'),FAMILY('ABC')
#SYSTEM
#PREPARE
  #SET(%TPLName,'Email Programming Templates')
#ENDPREPARE

#TAB('Report As Email')
  #BOXED(' Email Programming Templates')
    #DISPLAY('')
    #DISPLAY('Email PROGRAMMING TEMPLATES')
    #DISPLAY('')
    #DISPLAY(' Written By David Potter')
    #DISPLAY('')
    #DISPLAY('')
  #ENDBOXED
#ENDTAB


#!---------------------------------------------------------------------------
#EXTENSION(EmailViewer,'Views saved metafiles'),PROCEDURE
#!---------------------------------------------------------------------------
#SHEET
  #TAB('Email Viewer')
    #DISPLAY('')
    #BOXED
      #DISPLAY('')
      #PROMPT('A. Detail Use Variable',FROM(%ReportControl)),%DetailUse
      #PROMPT('B. Image Control for Metafile',FROM(%ReportControl)),%ImgCtrl
      #DISPLAY('')
     #ENDBOXED
     #DISPLAY('')
  #ENDTAB
  #BUTTON('&Instructions')
  #SHEET
   #TAB('&General')
     #BOXED('Purpose')
     #DISPLAY('Instructions for Template Use')
      #DISPLAY(' This template will allow a user to view/print saved ')
      #DISPLAY('  metafiles from a control file pointing to the ')
      #DISPLAY('  location of the saved metafile')
      #DISPLAY('')
      #DISPLAY('Template must be used on a report procedure that')
      #DISPLAY('is the only procedure in an application.')
      #DISPLAY('Report procedure must consist of one detail')
      #DISPLAY('expanded to fill a standard 8.5 X 11 page')
      #DISPLAY('contaning a slightly smaller image control')
      #DISPLAY('The primary file for the report must contain')
      #DISPLAY('the following columns in specified order')
      #DISPLAY('    1) PageNo      SHORT')
      #DISPLAY('    2) FileName    STRING(128)')
      #DISPLAY('    3) Orientation STRING(1)')
      #DISPLAY('    4) PageSize    STRING(1)')
      #DISPLAY('')
      #DISPLAY('The file must also contain Global variable name attribute')
      #DISPLAY('Global variable must be first in list')
     #ENDBOXED
   #ENDTAB
   #TAB('&Prompt help')
     #DISPLAY('A. Select the detail control from list')
     #DISPLAY('    must have a use variable')
     #DISPLAY('')
     #DISPLAY('B. Select the image control from list')
   #ENDTAB
 #ENDSHEET
 #ENDBUTTON
 #BUTTON('&Open Source')
    #SHEET
    #TAB('Agreement')
    #DISPLAY('-----------------------------------------------------------------------------')
    #DISPLAY(' Email Programming Templates. By David Potter')
    #DISPLAY('Template Source')
    #DISPLAY('-----------------------------------------------------------------------------')
    #DISPLAY(' The contents of this file are subject to the CoveComm Inc.')
    #DISPLAY(' Developers Open Source Public License Version 1.0 ')
    #DISPLAY(' (the "License"); you may not use this product except ')
    #DISPLAY(' in compliance with the License. You may obtain a ')
    #DISPLAY(' copy of the License at ')
    #DISPLAY(' http://www.clarionmag.com/common/dospl.html.')
    #DISPLAY(' Software distributed under the License is distributed ')
    #DISPLAY(' on an "AS IS" basis, ')
    #DISPLAY(' WITHOUT WARRANTY OF ANY KIND, ')
    #DISPLAY(' either express or implied. See the License for the ')
    #DISPLAY(' specific language governing rights and limitations ')
    #DISPLAY(' under the License. The Original Code is  copyright ')
    #DISPLAY(' by David Potter, released January 8, 2001. The Initial')
    #DISPLAY(' Developer of the Original Code is David Potter. ')
    #DISPLAY(' All Rights Reserved.')
    #DISPLAY(' ')
    #DISPLAY(' Contact: David Potter  dpotter@achillesusa.com')
    #DISPLAY('-----------------------------------------------------------------------------')
    #ENDTAB
    #ENDSHEET
  #ENDBUTTON
#ENDSHEET


#SELECT(%File,1)
#AT(%DataSection)
MetaQueue     PreviewQueue
#ENDAT

#SELECT(%File,1)
#AT(%ProgramSetup)
#SELECT(%GlobalData,1)
%GlobalData = COMMAND('1')

IF ~%GlobalData
  MESSAGE('A valid Metafile List must be supplied as a parameter')
  RETURN
END
#END

#AT(%ProcessManagerMethodCodeSection,'TakeRecord'),PRIORITY(5500)
#SELECT(%Field,2)
MetaQueue.FileName = %Field
ADD(MetaQueue)
SETTARGET(REPORT)
%ImgCtrl{prop:text} = %Field
SETTARGET()
#ENDAT
                                                 
#AT(%PreviewerManagerMethodCodeSection,'Init','(PreviewQueue ImageQueue)'),PRIORITY(4500)
PARENT.Init(MetaQueue)
RETURN
#ENDAT


#AT(%WindowManagerMethodCodeSection,'Init'),PRIORITY(9500)
SELF.Zoom = PageWidth          !Preset Zoom
Previewer.Maximize=True        !Start preview image at maximu
#ENDAT

#AT(%WindowManagerMethodCodeSection,'OpenReport')
SET(%File)
NEXT(%File)
SETTARGET(REPORT)
%ImgCtrl{PROP:XPOS} = 0              !Set ImageControl Position
%ImgCtrl{PROP:YPOS} = 250
#SELECT(%Field,3)
IF %Field = 'P'       ! Portrait Orientation
  %Report{PROP:LANDSCAPE}=False
   #SELECT(%Field,4)
  IF %Field = 'l'        ! Letter Sized Paper
    %Report{PROP:WIDTH} = 8500
    %Report{PROP:HEIGHT} = 11000
    %DetailUse{PROP:WIDTH} = 8500
    %DetailUse{PROP:HEIGHT} = 11000
    %ImgCtrl{PROP:WIDTH} = 8500
    %ImgCtrl{PROP:HEIGHT} = 10500
  ELSE                                 !Legal Paper
    %Report{PROP:WIDTH} = 8500
    %Report{PROP:HEIGHT} = 14000
    %DetailUse{PROP:WIDTH} = 8500
    %DetailUse{PROP:HEIGHT} = 14000
    %ImgCtrl{PROP:WIDTH} = 8500
    %ImgCtrl{PROP:HEIGHT} = 13500
  END                                  
ELSE                                   !Landscape Orientation
  %Report{PROP:LANDSCAPE}=True
   #SELECT(%Field,4)
  IF %Field = 'l'        !Letter Size Paper
    %Report{PROP:WIDTH} = 11000
    %Report{PROP:HEIGHT} = 8500
    %DetailUse{PROP:WIDTH} = 11000
    %DetailUse{PROP:HEIGHT} = 8500
    %ImgCtrl{PROP:WIDTH} = 11000
    %ImgCtrl{PROP:HEIGHT} = 8000
  ELSE                                 !Legal Paper
    %Report{PROP:WIDTH} = 14000
    %Report{PROP:HEIGHT} = 8500
    %DetailUse{PROP:WIDTH} = 14000
    %DetailUse{PROP:HEIGHT} = 8500
    %ImgCtrl{PROP:WIDTH} = 13500
    %ImgCtrl{PROP:HEIGHT} = 8500
  END
END
SETTARGET
#ENDAT



#!---------------------------------------------------------------------------
#EXTENSION(EmailReport,'Save metafiles to email report'),PROCEDURE
#!---------------------------------------------------------------------------
#SHEET
  #TAB('')
    #BOXED
     #DISPLAY('Email Report')
    #ENDBOXED
     #PROMPT('A. Metafile Table',FROM(%File)),%MetaListTable,DEFAULT('METAFILE')
     #PROMPT('B. Metafile Directory',@S128),%DirMeta,DEFAULT('s:\clarsys\metafiles')
     #PROMPT('C. Starts With',@S3),%FirstLetters,DEFAULT('PP')
     #PROMPT('D. Attached extension',@s3),%AttachExt,DEFAULT('pvw')
     #PROMPT('E. Email Procedure',PROCEDURE),%EmailProc
     #PROMPT('F. Parameters Use ()',@s80),%EmailParams
  #ENDTAB
  #BUTTON('&Instructions')
  #SHEET
   #TAB('&General')
     #DISPLAY('Instructions for Template Use')
     #BOXED
     #DISPLAY('Purpose: Save metafiles generated to directory ')
     #DISPLAY('and build a file listing location of metafiles')
     #DISPLAY('to send to email recipient')
     #ENDBOXED
     #BOXED
     #DISPLAY('Recipient must be on network and')
     #DISPLAY('have the metaviewer configured')
     #DISPLAY('')
     #DISPLAY(' Flag GLO:SendAsEmail must be set to email report')
     #ENDBOXED
   #ENDTAB
   #TAB('&Prompt help')
     #DISPLAY('A.  Select TPS table defined in data dictionary')
     #DISPLAY('    to hold metafile list')
     #DISPLAY('    Table must contain following columns')
     #DISPLAY('    (in specified order)')
     #DISPLAY('    1) PageNo      SHORT')
     #DISPLAY('    2) FileName    STRING(128)')
     #DISPLAY('    3) Orientation STRING(1)')
     #DISPLAY('    4) PageSize    STRING(1)')
     #DISPLAY('NOTE: You may use your own field names ')
     #DISPLAY('      Type and order are important')
     #DISPLAY('    Must contain Global variable name attribute')
     #DISPLAY('')
     #DISPLAY('B.  Select Network directory to save metafiles ')
     #DISPLAY('    All recipients must have read rights to directory')
     #DISPLAY('')
     #DISPLAY('C.  Enter the First three letters for TPS')
     #DISPLAY('    and metafiles generated')
     #DISPLAY('    Useful to identify which report ')
     #DISPLAY('    generated particular metafile')
     #DISPLAY('')
     #DISPLAY('D.  Enter extension you wish to use for TPS file')
     #DISPLAY('        (Extension must be unique)')
     #DISPLAY('')
     #DISPLAY('E.  Select email procedure in application')
     #DISPLAY('')
     #DISPLAY('F.  Include any parameters email procedure may require')
 #ENDTAB
 #ENDSHEET
   #ENDBUTTON
 #BUTTON('&Open Source')
    #SHEET
    #TAB('Agreement')
    #DISPLAY('-----------------------------------------------------------------------------')
    #DISPLAY(' Email Programming Templates. By David Potter')
    #DISPLAY('Template Source')
    #DISPLAY('-----------------------------------------------------------------------------')
    #DISPLAY(' The contents of this file are subject to the CoveComm Inc.')
    #DISPLAY(' Developers Open Source Public License Version 1.0 ')
    #DISPLAY(' (the "License"); you may not use this product except ')
    #DISPLAY(' in compliance with the License. You may obtain a ')
    #DISPLAY(' copy of the License at ')
    #DISPLAY(' http://www.clarionmag.com/common/dospl.html.')
    #DISPLAY(' Software distributed under the License is distributed ')
    #DISPLAY(' on an "AS IS" basis, ')
    #DISPLAY(' WITHOUT WARRANTY OF ANY KIND, ')
    #DISPLAY(' either express or implied. See the License for the ')
    #DISPLAY(' specific language governing rights and limitations ')
    #DISPLAY(' under the License. The Original Code is  copyright ')
    #DISPLAY(' by David Potter, released January 8, 2001. The Initial')
    #DISPLAY(' Developer of the Original Code is David Potter. ')
    #DISPLAY(' All Rights Reserved.')
    #DISPLAY(' ')
    #DISPLAY(' Contact: David Potter  dpotter@achillesusa.com')
    #DISPLAY('-----------------------------------------------------------------------------')
    #ENDTAB
    #ENDSHEET
  #ENDBUTTON
#ENDSHEET


#GLOBALDATA
  Glo:SendAsEmail    BYTE
#ENDGLOBALDATA

#AT(%AfterGlobalIncludes)
INCLUDE('PRNPROP.CLW'),ONCE
#ENDAT

#AT(%WindowManagerMethodCodeSection,'Init'),PRIORITY(9500)
  IF Glo:SendAsEmail             !Ensure Preview option is on
    SELF.SkipPreview = False
  END
#ENDAT


#! Set Local variables in the Display method
#AT(%PreviewerMethodDataSection,'Display')
Idx     SHORT                !Index For Loop
MetaDir STRING(128)          !Directory to save metafiles
Orientation STRING(1)        !Variable to save page orientation
PageSize    STRING(1)        !Variable to save pagesize
#ENDAT
          

#AT(%PreviewerManagerMethodCodeSection,'Display'),PRIORITY(2501)
#FIX(%File,%MetaListTable)
IF Glo:SendAsEmail
  IF %Report{PROP:LANDSCAPE}                  !Get Lanscape mode
    Orientation = 'L'
  ELSE
    Orientation = 'P'
  END

  IF %Report{PROPPRINT:PAPER} = PAPER:LETTER  !Get Paper Size
    PageSize = 'l'
  ELSE
    PageSize = 'L'
  END

  !Create Random filename for pvw file
  %FileName = CLIP('%FirstLetters') & FORMAT(RANDOM(1,99999),@N05) & '.%AttachExt'
  MetaDir = '%DirMeta'
  Relate:%MetaListTable.Open()

  LOOP Idx = 1 TO RECORDS(SELF.ImageQueue)
    CLEAR(%FilePrefix:Record)
    GET(SELF.ImageQueue,Idx)
    #SELECT(%Field,1)
    %Field = Idx
    #SELECT(%Field,2)
    %Field = CLIP(MetaDir) & '\' & '%FirstLetters' & SELF.ImageQueue.Filename[INSTRING('CLA',SELF.ImageQueue.Filename,1,1)+3 : LEN(CLIP(SELF.ImageQueue.Filename))-3] & 'wmf'
    COPY(SELF.ImageQueue.FileName,%FilePrefix:FileName)
    #SELECT(%Field,3)
    %Field = Orientation
    #SELECT(%Field,4)
    %Field = PageSize

    ADD(%MetaListTable)
  END

  Relate:%MetaListTable.Close()
  %EmailProc%EmailParams          !Call Email Procedure
  REMOVE(%MetaListTable)          !Delete File after it has been sent
  RETURN(0)                       !Disable Print Preview
END
#ENDAT


